#include "by_nav_x2_can_v0.hpp"

#include <iostream>

#include "CanMessage.h"

#include "Messages.h"

void CanMessage::control_request1_msg_parser(SWC2CAN message)
{

}

void CanMessage::handle_can_message(uint8_t *data,
		                unsigned int can_id,
						uint64_t timestamp_s,
						uint64_t timestamp_ns,
						uint8_t CRC)
{
    switch (can_id)
    {
    
case ULTRASONIC_RADAR_MESSAGE_HS_CAN_100_FRAME_ID:
    {
        // unpack
        ultrasonic_radar_message_hs_can_100_t *unpack_base = new ultrasonic_radar_message_hs_can_100_t();
        ultrasonic_radar_message_hs_can_100_unpack(unpack_base, data, 8);
        
        physical_message_hs_can_100_t& phys_struct = Can::Messages::get_instance()->get_all_messages().Message_HS_CAN_100_Signals;

        // decode
        phys_struct.pas_mode = ultrasonic_radar_message_hs_can_100_pas_mode_decode(unpack_base->message_hs_can_100_pas_mode);
        phys_struct.pas_warn_tone = ultrasonic_radar_message_hs_can_100_pas_warn_tone_decode(unpack_base->message_hs_can_100_pas_warn_tone);
        phys_struct.pas_rl_distance = ultrasonic_radar_message_hs_can_100_pas_rl_distance_decode(unpack_base->message_hs_can_100_pas_rl_distance);
        phys_struct.pas_rl_mid_distance = ultrasonic_radar_message_hs_can_100_pas_rl_mid_distance_decode(unpack_base->message_hs_can_100_pas_rl_mid_distance);
        phys_struct.pas_rr_mid_distance = ultrasonic_radar_message_hs_can_100_pas_rr_mid_distance_decode(unpack_base->message_hs_can_100_pas_rr_mid_distance);
        phys_struct.pas_rr_distance = ultrasonic_radar_message_hs_can_100_pas_rr_distance_decode(unpack_base->message_hs_can_100_pas_rr_distance);

        phys_struct.timestamp_s = timestamp_s;
        phys_struct.timestamp_ns = timestamp_ns;
        phys_struct.crc8 = CRC;

        break;
    }

case ULTRASONIC_RADAR_MESSAGE_HS_CAN_101_FRAME_ID:
    {
        // unpack
        ultrasonic_radar_message_hs_can_101_t *unpack_base = new ultrasonic_radar_message_hs_can_101_t();
        ultrasonic_radar_message_hs_can_101_unpack(unpack_base, data, 8);
        
        physical_message_hs_can_101_t& phys_struct = Can::Messages::get_instance()->get_all_messages().Message_HS_CAN_101_Signals;
        
        phys_struct.pas_fl_distance = ultrasonic_radar_message_hs_can_101_pas_fl_distance_decode(unpack_base->message_hs_can_101_pas_fl_distance);
        phys_struct.pas_fl_mid_distance = ultrasonic_radar_message_hs_can_101_pas_fl_mid_distance_decode(unpack_base->message_hs_can_101_pas_fl_mid_distance);
        phys_struct.pas_fr_mid_distance = ultrasonic_radar_message_hs_can_101_pas_fr_mid_distance_decode(unpack_base->message_hs_can_101_pas_fr_mid_distance);
        phys_struct.pas_fr_distance = ultrasonic_radar_message_hs_can_101_pas_fr_distance_decode(unpack_base->message_hs_can_101_pas_fr_distance);
        phys_struct.pas_rl_sns_err_flag = ultrasonic_radar_message_hs_can_101_pas_rl_sns_err_flag_decode(unpack_base->message_hs_can_101_pas_rl_sns_err_flag);
        phys_struct.pas_rl_mid_sns_err_flag = ultrasonic_radar_message_hs_can_101_pas_rl_mid_sns_err_flag_decode(unpack_base->message_hs_can_101_pas_rl_mid_sns_err_flag);
        phys_struct.pas_rr_mid_sns_err_flag = ultrasonic_radar_message_hs_can_101_pas_rr_mid_sns_err_flag_decode(unpack_base->message_hs_can_101_pas_rr_mid_sns_err_flag);
        phys_struct.pas_rr_sns_err_flag = ultrasonic_radar_message_hs_can_101_pas_rr_sns_err_flag_decode(unpack_base->message_hs_can_101_pas_rr_sns_err_flag);
        phys_struct.pas_fl_sns_err_flag = ultrasonic_radar_message_hs_can_101_pas_fl_sns_err_flag_decode(unpack_base->message_hs_can_101_pas_fl_sns_err_flag);
        phys_struct.pas_fl_mid_sns_err_flag = ultrasonic_radar_message_hs_can_101_pas_fl_mid_sns_err_flag_decode(unpack_base->message_hs_can_101_pas_fl_mid_sns_err_flag);
        phys_struct.pas_fr_mid_sns_err_flag = ultrasonic_radar_message_hs_can_101_pas_fr_mid_sns_err_flag_decode(unpack_base->message_hs_can_101_pas_fr_mid_sns_err_flag);
        phys_struct.pas_fr_sns_err_flag = ultrasonic_radar_message_hs_can_101_pas_fr_sns_err_flag_decode(unpack_base->message_hs_can_101_pas_fr_sns_err_flag);

        phys_struct.timestamp_s = timestamp_s;
        phys_struct.timestamp_ns = timestamp_ns;
        phys_struct.crc8 = CRC;

        break;
    }

case BY_NAV_X2_CAN_V0_1_DEVSTATUS_FRAME_ID:
    {
        // unpack
        by_nav_x2_can_v0_1_devstatus_t *unpack_base = new by_nav_x2_can_v0_1_devstatus_t();
        by_nav_x2_can_v0_1_devstatus_unpack(unpack_base, data, 8);

        // decode
        physical_devstatus_t& phys_struct = Can::Messages::get_instance()->get_all_messages().DEVSTATUS_Signals;

        phys_struct.devstatus_ap_temperatue = by_nav_x2_can_v0_1_devstatus_devstatus_ap_temperatue_decode(unpack_base->devstatus_ap_temperatue);
		
        
        phys_struct.timestamp_s = timestamp_s;
        phys_struct.timestamp_ns = timestamp_ns;
        phys_struct.crc8 = CRC;

        break;
    }

case BY_NAV_X2_CAN_V0_1_HEADING_ANGLE_FRAME_ID:
    {
        // unpack
        by_nav_x2_can_v0_1_heading_angle_t *unpack_base = new by_nav_x2_can_v0_1_heading_angle_t();
        by_nav_x2_can_v0_1_heading_angle_unpack(unpack_base, data, 8);

        // decode
        physical_heading_angle_t& phys_struct = Can::Messages::get_instance()->get_all_messages().HEADING_ANGLE_Signals;

        phys_struct.heading_heading = by_nav_x2_can_v0_1_heading_angle_heading_heading_decode(unpack_base->heading_heading);
		phys_struct.heading_pitch = by_nav_x2_can_v0_1_heading_angle_heading_pitch_decode(unpack_base->heading_pitch);
		phys_struct.heading_heading_std = by_nav_x2_can_v0_1_heading_angle_heading_heading_std_decode(unpack_base->heading_heading_std);
		phys_struct.heading_pitch_std = by_nav_x2_can_v0_1_heading_angle_heading_pitch_std_decode(unpack_base->heading_pitch_std);
		phys_struct.heading_length = by_nav_x2_can_v0_1_heading_angle_heading_length_decode(unpack_base->heading_length);
		
        
        phys_struct.timestamp_s = timestamp_s;
        phys_struct.timestamp_ns = timestamp_ns;
        phys_struct.crc8 = CRC;

        break;
    }

case BY_NAV_X2_CAN_V0_1_GNSS_SOL_RESULT_LATENCY_FRAME_ID:
    {
        // unpack
        by_nav_x2_can_v0_1_gnss_sol_result_latency_t *unpack_base = new by_nav_x2_can_v0_1_gnss_sol_result_latency_t();
        by_nav_x2_can_v0_1_gnss_sol_result_latency_unpack(unpack_base, data, 8);

        // decode
        physical_gnss_sol_result_latency_t& phys_struct = Can::Messages::get_instance()->get_all_messages().GNSS_SOL_RESULT_LATENCY_Signals;

        phys_struct.gnss_measure_latency = by_nav_x2_can_v0_1_gnss_sol_result_latency_gnss_measure_latency_decode(unpack_base->gnss_measure_latency);
		phys_struct.gnss_diff_age = by_nav_x2_can_v0_1_gnss_sol_result_latency_gnss_diff_age_decode(unpack_base->gnss_diff_age);
		
        
        phys_struct.timestamp_s = timestamp_s;
        phys_struct.timestamp_ns = timestamp_ns;
//        phys_struct.crc8 = CRC;

        break;
    }

case BY_NAV_X2_CAN_V0_1_INS_SOL_RESULT_STATUS_FRAME_ID:
    {
        // unpack
        by_nav_x2_can_v0_1_ins_sol_result_status_t *unpack_base = new by_nav_x2_can_v0_1_ins_sol_result_status_t();
        by_nav_x2_can_v0_1_ins_sol_result_status_unpack(unpack_base, data, 8);

        // decode
        physical_ins_sol_result_status_t& phys_struct = Can::Messages::get_instance()->get_all_messages().INS_SOL_RESULT_STATUS_Signals;

        phys_struct.ins_ins_status = by_nav_x2_can_v0_1_ins_sol_result_status_ins_ins_status_decode(unpack_base->ins_ins_status);
		phys_struct.ins_pos_type = by_nav_x2_can_v0_1_ins_sol_result_status_ins_pos_type_decode(unpack_base->ins_pos_type);
		
        
        phys_struct.timestamp_s = timestamp_s;
        phys_struct.timestamp_ns = timestamp_ns;
        phys_struct.crc8 = CRC;

        break;
    }

case BY_NAV_X2_CAN_V0_1_INS_SOL_RESULT_VEL_STD_FRAME_ID:
    {
        // unpack
        by_nav_x2_can_v0_1_ins_sol_result_vel_std_t *unpack_base = new by_nav_x2_can_v0_1_ins_sol_result_vel_std_t();
        by_nav_x2_can_v0_1_ins_sol_result_vel_std_unpack(unpack_base, data, 8);

        // decode
        physical_ins_sol_result_vel_std_t& phys_struct = Can::Messages::get_instance()->get_all_messages().INS_SOL_RESULT_VEL_STD_Signals;

        phys_struct.ins_velocity_std = by_nav_x2_can_v0_1_ins_sol_result_vel_std_ins_velocity_std_decode(unpack_base->ins_velocity_std);
		phys_struct.ins_velocity_e_std = by_nav_x2_can_v0_1_ins_sol_result_vel_std_ins_velocity_e_std_decode(unpack_base->ins_velocity_e_std);
		phys_struct.ins_velocity_n_std = by_nav_x2_can_v0_1_ins_sol_result_vel_std_ins_velocity_n_std_decode(unpack_base->ins_velocity_n_std);
		phys_struct.ins_velocity_u_std = by_nav_x2_can_v0_1_ins_sol_result_vel_std_ins_velocity_u_std_decode(unpack_base->ins_velocity_u_std);
		
        
        phys_struct.timestamp_s = timestamp_s;
        phys_struct.timestamp_ns = timestamp_ns;
        phys_struct.crc8 = CRC;

        break;
    }

case BY_NAV_X2_CAN_V0_1_INS_SOL_RESULT_VEL_FRAME_ID:
    {
        // unpack
        by_nav_x2_can_v0_1_ins_sol_result_vel_t *unpack_base = new by_nav_x2_can_v0_1_ins_sol_result_vel_t();
        by_nav_x2_can_v0_1_ins_sol_result_vel_unpack(unpack_base, data, 8);

        // decode
        physical_ins_sol_result_vel_t& phys_struct = Can::Messages::get_instance()->get_all_messages().INS_SOL_RESULT_VEL_Signals;

        phys_struct.ins_velocity = by_nav_x2_can_v0_1_ins_sol_result_vel_ins_velocity_decode(unpack_base->ins_velocity);
		phys_struct.ins_velocity_e = by_nav_x2_can_v0_1_ins_sol_result_vel_ins_velocity_e_decode(unpack_base->ins_velocity_e);
		phys_struct.ins_velocity_n = by_nav_x2_can_v0_1_ins_sol_result_vel_ins_velocity_n_decode(unpack_base->ins_velocity_n);
		phys_struct.ins_velocity_u = by_nav_x2_can_v0_1_ins_sol_result_vel_ins_velocity_u_decode(unpack_base->ins_velocity_u);
		
        
        phys_struct.timestamp_s = timestamp_s;
        phys_struct.timestamp_ns = timestamp_ns;
        phys_struct.crc8 = CRC;

        break;
    }

case BY_NAV_X2_CAN_V0_1_INS_SOL_RESULT_ANGLE_STD_FRAME_ID:
    {
        // unpack
        by_nav_x2_can_v0_1_ins_sol_result_angle_std_t *unpack_base = new by_nav_x2_can_v0_1_ins_sol_result_angle_std_t();
        by_nav_x2_can_v0_1_ins_sol_result_angle_std_unpack(unpack_base, data, 8);

        // decode
        physical_ins_sol_result_angle_std_t& phys_struct = Can::Messages::get_instance()->get_all_messages().INS_SOL_RESULT_ANGLE_STD_Signals;

        phys_struct.ins_course_angle_std = by_nav_x2_can_v0_1_ins_sol_result_angle_std_ins_course_angle_std_decode(unpack_base->ins_course_angle_std);
		phys_struct.ins_yaw_angle_std = by_nav_x2_can_v0_1_ins_sol_result_angle_std_ins_yaw_angle_std_decode(unpack_base->ins_yaw_angle_std);
		phys_struct.ins_pitch_std = by_nav_x2_can_v0_1_ins_sol_result_angle_std_ins_pitch_std_decode(unpack_base->ins_pitch_std);
		phys_struct.ins_roll_std = by_nav_x2_can_v0_1_ins_sol_result_angle_std_ins_roll_std_decode(unpack_base->ins_roll_std);
		
        
        phys_struct.timestamp_s = timestamp_s;
        phys_struct.timestamp_ns = timestamp_ns;
        phys_struct.crc8 = CRC;

        break;
    }

case BY_NAV_X2_CAN_V0_1_INS_SOL_RESULT_ANGLE_FRAME_ID:
    {
        // unpack
        by_nav_x2_can_v0_1_ins_sol_result_angle_t *unpack_base = new by_nav_x2_can_v0_1_ins_sol_result_angle_t();
        by_nav_x2_can_v0_1_ins_sol_result_angle_unpack(unpack_base, data, 8);

        // decode
        physical_ins_sol_result_angle_t& phys_struct = Can::Messages::get_instance()->get_all_messages().INS_SOL_RESULT_ANGLE_Signals;

        phys_struct.ins_course_angle = by_nav_x2_can_v0_1_ins_sol_result_angle_ins_course_angle_decode(unpack_base->ins_course_angle);
		phys_struct.ins_yaw_angle = by_nav_x2_can_v0_1_ins_sol_result_angle_ins_yaw_angle_decode(unpack_base->ins_yaw_angle);
		phys_struct.ins_pitch = by_nav_x2_can_v0_1_ins_sol_result_angle_ins_pitch_decode(unpack_base->ins_pitch);
		phys_struct.ins_roll = by_nav_x2_can_v0_1_ins_sol_result_angle_ins_roll_decode(unpack_base->ins_roll);
		
        
        phys_struct.timestamp_s = timestamp_s;
        phys_struct.timestamp_ns = timestamp_ns;
        phys_struct.crc8 = CRC;


        break;
    }

case BY_NAV_X2_CAN_V0_1_INS_SOL_RESULT_ALTITUDE_FRAME_ID:
    {
        // unpack
        by_nav_x2_can_v0_1_ins_sol_result_altitude_t *unpack_base = new by_nav_x2_can_v0_1_ins_sol_result_altitude_t();
        by_nav_x2_can_v0_1_ins_sol_result_altitude_unpack(unpack_base, data, 8);

        // decode
        physical_ins_sol_result_altitude_t& phys_struct = Can::Messages::get_instance()->get_all_messages().INS_SOL_RESULT_ALTITUDE_Signals;

        phys_struct.ins_altitude = by_nav_x2_can_v0_1_ins_sol_result_altitude_ins_altitude_decode(unpack_base->ins_altitude);
		phys_struct.ins_altitude_std = by_nav_x2_can_v0_1_ins_sol_result_altitude_ins_altitude_std_decode(unpack_base->ins_altitude_std);
		phys_struct.ins_undulation = by_nav_x2_can_v0_1_ins_sol_result_altitude_ins_undulation_decode(unpack_base->ins_undulation);
		
        
        phys_struct.timestamp_s = timestamp_s;
        phys_struct.timestamp_ns = timestamp_ns;
        phys_struct.crc8 = CRC;


        break;
    }

case BY_NAV_X2_CAN_V0_1_INS_SOL_RESULT_LONGITUDE_FRAME_ID:
    {
        // unpack
        by_nav_x2_can_v0_1_ins_sol_result_longitude_t *unpack_base = new by_nav_x2_can_v0_1_ins_sol_result_longitude_t();
        by_nav_x2_can_v0_1_ins_sol_result_longitude_unpack(unpack_base, data, 8);

        // decode
        physical_ins_sol_result_longitude_t& phys_struct = Can::Messages::get_instance()->get_all_messages().INS_SOL_RESULT_LONGITUDE_Signals;;

        phys_struct.ins_longitude = by_nav_x2_can_v0_1_ins_sol_result_longitude_ins_longitude_decode(unpack_base->ins_longitude);
		phys_struct.ins_longitude_std = by_nav_x2_can_v0_1_ins_sol_result_longitude_ins_longitude_std_decode(unpack_base->ins_longitude_std);
		
        
        phys_struct.timestamp_s = timestamp_s;
        phys_struct.timestamp_ns = timestamp_ns;
        phys_struct.crc8 = CRC;


        break;
    }

case BY_NAV_X2_CAN_V0_1_INS_SOL_RESULT_LATITUDE_FRAME_ID:
    {
        // unpack
        by_nav_x2_can_v0_1_ins_sol_result_latitude_t *unpack_base = new by_nav_x2_can_v0_1_ins_sol_result_latitude_t();
        by_nav_x2_can_v0_1_ins_sol_result_latitude_unpack(unpack_base, data, 8);

        // decode
        physical_ins_sol_result_latitude_t& phys_struct = Can::Messages::get_instance()->get_all_messages().INS_SOL_RESULT_LATITUDE_Signals;

        phys_struct.ins_latitude = by_nav_x2_can_v0_1_ins_sol_result_latitude_ins_latitude_decode(unpack_base->ins_latitude);
		phys_struct.ins_latitude_std = by_nav_x2_can_v0_1_ins_sol_result_latitude_ins_latitude_std_decode(unpack_base->ins_latitude_std);
		
        
        phys_struct.timestamp_s = timestamp_s;
        phys_struct.timestamp_ns = timestamp_ns;
        phys_struct.crc8 = CRC;


        break;
    }

case BY_NAV_X2_CAN_V0_1_INS_SOL_RESULT_COMMON_FRAME_ID:
    {
        // unpack
        by_nav_x2_can_v0_1_ins_sol_result_common_t *unpack_base = new by_nav_x2_can_v0_1_ins_sol_result_common_t();
        by_nav_x2_can_v0_1_ins_sol_result_common_unpack(unpack_base, data, 8);

        // decode
        physical_ins_sol_result_common_t& phys_struct = Can::Messages::get_instance()->get_all_messages().INS_SOL_RESULT_COMMON_Signals;

        phys_struct.ins_gps_week = by_nav_x2_can_v0_1_ins_sol_result_common_ins_gps_week_decode(unpack_base->ins_gps_week);
		phys_struct.ins_gps_sow = by_nav_x2_can_v0_1_ins_sol_result_common_ins_gps_sow_decode(unpack_base->ins_gps_sow);
		
        
        phys_struct.timestamp_s = timestamp_s;
        phys_struct.timestamp_ns = timestamp_ns;
        phys_struct.crc8 = CRC;


        break;
    }

case BY_NAV_X2_CAN_V0_1_GNSS_SOL_RESULT_SPD_FRAME_ID:
    {
        // unpack
        by_nav_x2_can_v0_1_gnss_sol_result_spd_t *unpack_base = new by_nav_x2_can_v0_1_gnss_sol_result_spd_t();
        by_nav_x2_can_v0_1_gnss_sol_result_spd_unpack(unpack_base, data, 8);

        // decode
        physical_gnss_sol_result_spd_t& phys_struct = Can::Messages::get_instance()->get_all_messages().GNSS_SOL_RESULT_SPD_Signals;

        phys_struct.gnss_horizontal_spd = by_nav_x2_can_v0_1_gnss_sol_result_spd_gnss_horizontal_spd_decode(unpack_base->gnss_horizontal_spd);
		phys_struct.gnss_track_over_ground = by_nav_x2_can_v0_1_gnss_sol_result_spd_gnss_track_over_ground_decode(unpack_base->gnss_track_over_ground);
		phys_struct.gnss_vertical_spd = by_nav_x2_can_v0_1_gnss_sol_result_spd_gnss_vertical_spd_decode(unpack_base->gnss_vertical_spd);
		
        
        phys_struct.timestamp_s = timestamp_s;
        phys_struct.timestamp_ns = timestamp_ns;
        phys_struct.crc8 = CRC;


        break;
    }

case BY_NAV_X2_CAN_V0_1_GNSS_SOL_RESULT_ALTITUDE_FRAME_ID:
    {
        // unpack
        by_nav_x2_can_v0_1_gnss_sol_result_altitude_t *unpack_base = new by_nav_x2_can_v0_1_gnss_sol_result_altitude_t();
        by_nav_x2_can_v0_1_gnss_sol_result_altitude_unpack(unpack_base, data, 8);

        // decode
        physical_gnss_sol_result_altitude_t& phys_struct = Can::Messages::get_instance()->get_all_messages().GNSS_SOL_RESULT_ALTITUDE_Signals;

        phys_struct.gnss_altitude = by_nav_x2_can_v0_1_gnss_sol_result_altitude_gnss_altitude_decode(unpack_base->gnss_altitude);
		phys_struct.gnss_altitude_std = by_nav_x2_can_v0_1_gnss_sol_result_altitude_gnss_altitude_std_decode(unpack_base->gnss_altitude_std);
		phys_struct.gnss_undulation = by_nav_x2_can_v0_1_gnss_sol_result_altitude_gnss_undulation_decode(unpack_base->gnss_undulation);
		
        
        phys_struct.timestamp_s = timestamp_s;
        phys_struct.timestamp_ns = timestamp_ns;
        phys_struct.crc8 = CRC;


        break;
    }

case BY_NAV_X2_CAN_V0_1_GNSS_SOL_RESULT_LONGITUDE_FRAME_ID:
    {
        // unpack
        by_nav_x2_can_v0_1_gnss_sol_result_longitude_t *unpack_base = new by_nav_x2_can_v0_1_gnss_sol_result_longitude_t();
        by_nav_x2_can_v0_1_gnss_sol_result_longitude_unpack(unpack_base, data, 8);

        // decode
        physical_gnss_sol_result_longitude_t& phys_struct = Can::Messages::get_instance()->get_all_messages().GNSS_SOL_RESULT_LONGITUDE_Signals;

        phys_struct.gnss_longitude = by_nav_x2_can_v0_1_gnss_sol_result_longitude_gnss_longitude_decode(unpack_base->gnss_longitude);
		phys_struct.gnss_longitude_std = by_nav_x2_can_v0_1_gnss_sol_result_longitude_gnss_longitude_std_decode(unpack_base->gnss_longitude_std);
		
        
        phys_struct.timestamp_s = timestamp_s;
        phys_struct.timestamp_ns = timestamp_ns;
        phys_struct.crc8 = CRC;

        break;
    }

case BY_NAV_X2_CAN_V0_1_GNSS_SOL_RESULT_LATITUDE_FRAME_ID:
    {
        // unpack
        by_nav_x2_can_v0_1_gnss_sol_result_latitude_t *unpack_base = new by_nav_x2_can_v0_1_gnss_sol_result_latitude_t();
        by_nav_x2_can_v0_1_gnss_sol_result_latitude_unpack(unpack_base, data, 8);

        // decode
        physical_gnss_sol_result_latitude_t& phys_struct = Can::Messages::get_instance()->get_all_messages().GNSS_SOL_RESULT_LATITUDE_Signals;

        phys_struct.gnss_latitude = by_nav_x2_can_v0_1_gnss_sol_result_latitude_gnss_latitude_decode(unpack_base->gnss_latitude);
		phys_struct.gnss_latitude_std = by_nav_x2_can_v0_1_gnss_sol_result_latitude_gnss_latitude_std_decode(unpack_base->gnss_latitude_std);
		
        
        phys_struct.timestamp_s = timestamp_s;
        phys_struct.timestamp_ns = timestamp_ns;
        phys_struct.crc8 = CRC;



        break;
    }

case BY_NAV_X2_CAN_V0_1_GNSS_SOL_RESULT_STATUS_FRAME_ID:
    {
        // unpack
        by_nav_x2_can_v0_1_gnss_sol_result_status_t *unpack_base = new by_nav_x2_can_v0_1_gnss_sol_result_status_t();
        by_nav_x2_can_v0_1_gnss_sol_result_status_unpack(unpack_base, data, 8);

        // decode
        physical_gnss_sol_result_status_t& phys_struct = Can::Messages::get_instance()->get_all_messages().GNSS_SOL_RESULT_STATUS_Signals;

        phys_struct.gnss_postion_type = by_nav_x2_can_v0_1_gnss_sol_result_status_gnss_postion_type_decode(unpack_base->gnss_postion_type);
		phys_struct.gnss_solution_type = by_nav_x2_can_v0_1_gnss_sol_result_status_gnss_solution_type_decode(unpack_base->gnss_solution_type);
		phys_struct.heading_position_type = by_nav_x2_can_v0_1_gnss_sol_result_status_heading_position_type_decode(unpack_base->heading_position_type);
		phys_struct.heading_solution_type = by_nav_x2_can_v0_1_gnss_sol_result_status_heading_solution_type_decode(unpack_base->heading_solution_type);
		phys_struct.gnss_velocity_type = by_nav_x2_can_v0_1_gnss_sol_result_status_gnss_velocity_type_decode(unpack_base->gnss_velocity_type);
		
        
        phys_struct.timestamp_s = timestamp_s;
        phys_struct.timestamp_ns = timestamp_ns;
        phys_struct.crc8 = CRC;

        break;
    }

case BY_NAV_X2_CAN_V0_1_GNSS_SOL_RESULT_COMMON_FRAME_ID:
    {
        // unpack
        by_nav_x2_can_v0_1_gnss_sol_result_common_t *unpack_base = new by_nav_x2_can_v0_1_gnss_sol_result_common_t();
        by_nav_x2_can_v0_1_gnss_sol_result_common_unpack(unpack_base, data, 8);

        // decode
        physical_gnss_sol_result_common_t& phys_struct = Can::Messages::get_instance()->get_all_messages().GNSS_SOL_RESULT_COMMON_Signals;

        phys_struct.gnss_gps_week = by_nav_x2_can_v0_1_gnss_sol_result_common_gnss_gps_week_decode(unpack_base->gnss_gps_week);
		phys_struct.gnss_gps_sow = by_nav_x2_can_v0_1_gnss_sol_result_common_gnss_gps_sow_decode(unpack_base->gnss_gps_sow);
		
        
        phys_struct.timestamp_s = timestamp_s;
        phys_struct.timestamp_ns = timestamp_ns;
        phys_struct.crc8 = CRC;


        break;
    }

case BY_NAV_X2_CAN_V0_1_GNSS_SOL_RESULT_DOP_FRAME_ID:
    {
        // unpack
        by_nav_x2_can_v0_1_gnss_sol_result_dop_t *unpack_base = new by_nav_x2_can_v0_1_gnss_sol_result_dop_t();
        by_nav_x2_can_v0_1_gnss_sol_result_dop_unpack(unpack_base, data, 8);

        // decode
        physical_gnss_sol_result_dop_t& phys_struct = Can::Messages::get_instance()->get_all_messages().GNSS_SOL_RESULT_DOP_Signals;

        phys_struct.gnss_hdop = by_nav_x2_can_v0_1_gnss_sol_result_dop_gnss_hdop_decode(unpack_base->gnss_hdop);
		phys_struct.gnss_pdop = by_nav_x2_can_v0_1_gnss_sol_result_dop_gnss_pdop_decode(unpack_base->gnss_pdop);
		phys_struct.gnss_vdop = by_nav_x2_can_v0_1_gnss_sol_result_dop_gnss_vdop_decode(unpack_base->gnss_vdop);
		
        
        phys_struct.timestamp_s = timestamp_s;
        phys_struct.timestamp_ns = timestamp_ns;
        phys_struct.crc8 = CRC;

        break;
    }

case BY_NAV_X2_CAN_V0_1_GNSS_SOL_RESULT_NUM_FRAME_ID:
    {
        // unpack
        by_nav_x2_can_v0_1_gnss_sol_result_num_t *unpack_base = new by_nav_x2_can_v0_1_gnss_sol_result_num_t();
        by_nav_x2_can_v0_1_gnss_sol_result_num_unpack(unpack_base, data, 8);

        // decode
        physical_gnss_sol_result_num_t& phys_struct = Can::Messages::get_instance()->get_all_messages().GNSS_SOL_RESULT_NUM_Signals;

        phys_struct.gnss_num_sats = by_nav_x2_can_v0_1_gnss_sol_result_num_gnss_num_sats_decode(unpack_base->gnss_num_sats);
		phys_struct.gnss_num_sats_used = by_nav_x2_can_v0_1_gnss_sol_result_num_gnss_num_sats_used_decode(unpack_base->gnss_num_sats_used);
		phys_struct.gnss_used_snr_avg = by_nav_x2_can_v0_1_gnss_sol_result_num_gnss_used_snr_avg_decode(unpack_base->gnss_used_snr_avg);
		phys_struct.heading_svs = by_nav_x2_can_v0_1_gnss_sol_result_num_heading_svs_decode(unpack_base->heading_svs);
		phys_struct.heading_soln_svs = by_nav_x2_can_v0_1_gnss_sol_result_num_heading_soln_svs_decode(unpack_base->heading_soln_svs);
		
        
        phys_struct.timestamp_s = timestamp_s;
        phys_struct.timestamp_ns = timestamp_ns;
        phys_struct.crc8 = CRC;


        break;
    }

case BY_NAV_X2_CAN_V0_1_IMU_BIAS_CORRECTED_COMMON_FRAME_ID:
    {
        // unpack
        by_nav_x2_can_v0_1_imu_bias_corrected_common_t *unpack_base = new by_nav_x2_can_v0_1_imu_bias_corrected_common_t();
        by_nav_x2_can_v0_1_imu_bias_corrected_common_unpack(unpack_base, data, 8);

        // decode
        physical_imu_bias_corrected_common_t& phys_struct = Can::Messages::get_instance()->get_all_messages().IMU_BIAS_CORRECTED_COMMON_Signals;

        phys_struct.imu_gps_week = by_nav_x2_can_v0_1_imu_bias_corrected_common_imu_gps_week_decode(unpack_base->imu_gps_week);
		phys_struct.imu_gps_sow = by_nav_x2_can_v0_1_imu_bias_corrected_common_imu_gps_sow_decode(unpack_base->imu_gps_sow);
		phys_struct.imu_temperatue = by_nav_x2_can_v0_1_imu_bias_corrected_common_imu_temperatue_decode(unpack_base->imu_temperatue);
		
        
        phys_struct.timestamp_s = timestamp_s;
        phys_struct.timestamp_ns = timestamp_ns;
        phys_struct.crc8 = CRC;


        break;
    }

case BY_NAV_X2_CAN_V0_1_IMU_BIAS_CORRECTED_ANGRATE_FRAME_ID:
    {
        // unpack
        by_nav_x2_can_v0_1_imu_bias_corrected_angrate_t *unpack_base = new by_nav_x2_can_v0_1_imu_bias_corrected_angrate_t();
        by_nav_x2_can_v0_1_imu_bias_corrected_angrate_unpack(unpack_base, data, 8);

        // decode
        physical_imu_bias_corrected_angrate_t& phys_struct = Can::Messages::get_instance()->get_all_messages().IMU_BIAS_CORRECTED_ANGRATE_Signals;

        phys_struct.imu_bias_corrected_ang_rate_x = by_nav_x2_can_v0_1_imu_bias_corrected_angrate_imu_bias_corrected_ang_rate_x_decode(unpack_base->imu_bias_corrected_ang_rate_x);
		phys_struct.imu_bias_corrected_ang_rate_y = by_nav_x2_can_v0_1_imu_bias_corrected_angrate_imu_bias_corrected_ang_rate_y_decode(unpack_base->imu_bias_corrected_ang_rate_y);
		phys_struct.imu_bias_corrected_ang_rate_z = by_nav_x2_can_v0_1_imu_bias_corrected_angrate_imu_bias_corrected_ang_rate_z_decode(unpack_base->imu_bias_corrected_ang_rate_z);
		
        
        phys_struct.timestamp_s = timestamp_s;
        phys_struct.timestamp_ns = timestamp_ns;
        phys_struct.crc8 = CRC;


        break;
    }

case BY_NAV_X2_CAN_V0_1_IMU_BIAS_CORRECTED_ACC_FRAME_ID:
    {
        // unpack
        by_nav_x2_can_v0_1_imu_bias_corrected_acc_t *unpack_base = new by_nav_x2_can_v0_1_imu_bias_corrected_acc_t();
        by_nav_x2_can_v0_1_imu_bias_corrected_acc_unpack(unpack_base, data, 8);

        // decode
        physical_imu_bias_corrected_acc_t& phys_struct = Can::Messages::get_instance()->get_all_messages().IMU_BIAS_CORRECTED_ACC_Signals;

        phys_struct.imu_bias_corrected_acc_x = by_nav_x2_can_v0_1_imu_bias_corrected_acc_imu_bias_corrected_acc_x_decode(unpack_base->imu_bias_corrected_acc_x);
		phys_struct.imu_bias_corrected_acc_y = by_nav_x2_can_v0_1_imu_bias_corrected_acc_imu_bias_corrected_acc_y_decode(unpack_base->imu_bias_corrected_acc_y);
		phys_struct.imu_bias_corrected_acc_z = by_nav_x2_can_v0_1_imu_bias_corrected_acc_imu_bias_corrected_acc_z_decode(unpack_base->imu_bias_corrected_acc_z);
		
        
        phys_struct.timestamp_s = timestamp_s;
        phys_struct.timestamp_ns = timestamp_ns;
        phys_struct.crc8 = CRC;


        break;
    }

case BY_NAV_X2_CAN_V0_1_IMU_ORIGIN_COMMON_FRAME_ID:
    {
        // unpack
        by_nav_x2_can_v0_1_imu_origin_common_t *unpack_base = new by_nav_x2_can_v0_1_imu_origin_common_t();
        by_nav_x2_can_v0_1_imu_origin_common_unpack(unpack_base, data, 8);

        // decode
        physical_imu_origin_common_t& phys_struct = Can::Messages::get_instance()->get_all_messages().IMU_ORIGIN_COMMON_Signals;

        phys_struct.imu_ori_gps_week = by_nav_x2_can_v0_1_imu_origin_common_imu_ori_gps_week_decode(unpack_base->imu_ori_gps_week);
		phys_struct.imu_ori_gps_sow = by_nav_x2_can_v0_1_imu_origin_common_imu_ori_gps_sow_decode(unpack_base->imu_ori_gps_sow);
		phys_struct.imu_temperatue = by_nav_x2_can_v0_1_imu_origin_common_imu_temperatue_decode(unpack_base->imu_temperatue);
		
        
        phys_struct.timestamp_s = timestamp_s;
        phys_struct.timestamp_ns = timestamp_ns;
        phys_struct.crc8 = CRC;

        break;
    }

case BY_NAV_X2_CAN_V0_1_IMU_ORIGIN_ACC_FRAME_ID:
    {
        // unpack
        by_nav_x2_can_v0_1_imu_origin_acc_t *unpack_base = new by_nav_x2_can_v0_1_imu_origin_acc_t();
        by_nav_x2_can_v0_1_imu_origin_acc_unpack(unpack_base, data, 8);

        // decode
        physical_imu_origin_acc_t& phys_struct = Can::Messages::get_instance()->get_all_messages().IMU_ORIGIN_ACC_Signals;

        phys_struct.imu_ori_acc_x = by_nav_x2_can_v0_1_imu_origin_acc_imu_ori_acc_x_decode(unpack_base->imu_ori_acc_x);
		phys_struct.imu_ori_acc_y = by_nav_x2_can_v0_1_imu_origin_acc_imu_ori_acc_y_decode(unpack_base->imu_ori_acc_y);
		phys_struct.imu_ori_acc_z = by_nav_x2_can_v0_1_imu_origin_acc_imu_ori_acc_z_decode(unpack_base->imu_ori_acc_z);
		
        
        phys_struct.timestamp_s = timestamp_s;
        phys_struct.timestamp_ns = timestamp_ns;
        phys_struct.crc8 = CRC;


        break;
    }

case BY_NAV_X2_CAN_V0_1_IMU_ORIGIN_GYRO_FRAME_ID:
    {
        // unpack
        by_nav_x2_can_v0_1_imu_origin_gyro_t *unpack_base = new by_nav_x2_can_v0_1_imu_origin_gyro_t();
        by_nav_x2_can_v0_1_imu_origin_gyro_unpack(unpack_base, data, 8);

        // decode
        physical_imu_origin_gyro_t& phys_struct = Can::Messages::get_instance()->get_all_messages().IMU_ORIGIN_GYRO_Signals;

        phys_struct.imu_ori_gyro_x = by_nav_x2_can_v0_1_imu_origin_gyro_imu_ori_gyro_x_decode(unpack_base->imu_ori_gyro_x);
		phys_struct.imu_ori_gyro_y = by_nav_x2_can_v0_1_imu_origin_gyro_imu_ori_gyro_y_decode(unpack_base->imu_ori_gyro_y);
		phys_struct.imu_ori_gyro_z = by_nav_x2_can_v0_1_imu_origin_gyro_imu_ori_gyro_z_decode(unpack_base->imu_ori_gyro_z);
		
        
        phys_struct.timestamp_s = timestamp_s;
        phys_struct.timestamp_ns = timestamp_ns;
        phys_struct.crc8 = CRC;


        break;
    }

    case BY_NAV_X2_CAN_V0_1_CONTROL_REQUEST1_FRAME_ID:
    {
        // unpack
        by_nav_x2_can_v0_1_control_request1_t *unpack_base = new by_nav_x2_can_v0_1_control_request1_t();
        by_nav_x2_can_v0_1_control_request1_unpack(unpack_base, data, 8);

        // decode
//        physical_control_request1_t& phys_struct;
//
//		phys_struct.ipc_target_motor_en = by_nav_x2_can_v0_1_control_request1_ipc_target_motor_en_decode(unpack_base->ipc_target_motor_en);
//        phys_struct.ipc_target_gear = by_nav_x2_can_v0_1_control_request1_ipc_target_gear_decode(unpack_base->ipc_target_gear);
//        phys_struct.ipc_target_mode = by_nav_x2_can_v0_1_control_request1_ipc_target_mode_decode(unpack_base->ipc_target_mode);
//        phys_struct.ipc_life_signal = by_nav_x2_can_v0_1_control_request1_ipc_life_signal_decode(unpack_base->ipc_life_signal);
//        phys_struct.ipc_target_speed = by_nav_x2_can_v0_1_control_request1_ipc_target_speed_decode(unpack_base->ipc_target_speed);
//        phys_struct.ipc_target_spd_valid = by_nav_x2_can_v0_1_control_request1_ipc_target_spd_valid_decode(unpack_base->ipc_target_spd_valid);
//        phys_struct.ipc_target_brk_press = by_nav_x2_can_v0_1_control_request1_ipc_target_brk_press_decode(unpack_base->ipc_target_brk_press);
//        phys_struct.ipc_target_angle = by_nav_x2_can_v0_1_control_request1_ipc_target_angle_decode(unpack_base->ipc_target_angle);
//        phys_struct.ipc_target_steering_en = by_nav_x2_can_v0_1_control_request1_ipc_target_steering_en_decode(unpack_base->ipc_target_steering_en);
//        phys_struct.ipc_target_torque = by_nav_x2_can_v0_1_control_request1_ipc_target_torque_decode(unpack_base->ipc_target_torque);
//        phys_struct.ipc_torque_rpm_mode = by_nav_x2_can_v0_1_control_request1_ipc_torque_rpm_mode_decode(unpack_base->ipc_torque_rpm_mode);
//        phys_struct.ipc_turn_light = by_nav_x2_can_v0_1_control_request1_ipc_turn_light_decode(unpack_base->ipc_turn_light);
//        phys_struct.ipc_target_spd_mode = by_nav_x2_can_v0_1_control_request1_ipc_target_spd_mode_decode(unpack_base->ipc_target_spd_mode);
		
		
//
//        phys_struct.timestamp_s = timestamp_s;
//        phys_struct.timestamp_ns = timestamp_ns;
//        phys_struct.crc8 = CRC;


        break;
    }

    case BY_NAV_X2_CAN_V0_1_VCU_INFO_1_FRAME_ID:
    {
        // unpack
        by_nav_x2_can_v0_1_vcu_info_1_t *unpack_base = new by_nav_x2_can_v0_1_vcu_info_1_t();
        by_nav_x2_can_v0_1_vcu_info_1_unpack(unpack_base, data, 8);

        // decode
        physical_vcu_info_1_t& phys_struct = Can::Messages::get_instance()->get_all_messages().VCU_Info_1_Signals;

		phys_struct.current_angle = by_nav_x2_can_v0_1_vcu_info_1_current_angle_decode(unpack_base->current_angle);
        phys_struct.ses_en_sts = by_nav_x2_can_v0_1_vcu_info_1_ses_en_sts_decode(unpack_base->ses_en_sts);
        phys_struct.motor_en_sts = by_nav_x2_can_v0_1_vcu_info_1_motor_en_sts_decode(unpack_base->motor_en_sts);
        phys_struct.current_speed = by_nav_x2_can_v0_1_vcu_info_1_current_speed_decode(unpack_base->current_speed);
        phys_struct.motor_torque = by_nav_x2_can_v0_1_vcu_info_1_motor_torque_decode(unpack_base->motor_torque);
        phys_struct.vcu_mode = by_nav_x2_can_v0_1_vcu_info_1_vcu_mode_decode(unpack_base->vcu_mode);
        phys_struct.controller_online_sts = by_nav_x2_can_v0_1_vcu_info_1_controller_online_sts_decode(unpack_base->controller_online_sts);
        phys_struct.ipc_online_status = by_nav_x2_can_v0_1_vcu_info_1_ipc_online_status_decode(unpack_base->ipc_online_status);
        phys_struct.vcu_life_signal = by_nav_x2_can_v0_1_vcu_info_1_vcu_life_signal_decode(unpack_base->vcu_life_signal);
        phys_struct.current_brk_press = by_nav_x2_can_v0_1_vcu_info_1_current_brk_press_decode(unpack_base->current_brk_press);
        phys_struct.rseb_mode = by_nav_x2_can_v0_1_vcu_info_1_rseb_mode_decode(unpack_base->rseb_mode);
        phys_struct.battery_number = by_nav_x2_can_v0_1_vcu_info_1_battery_number_decode(unpack_base->battery_number);
        phys_struct.current_gear = by_nav_x2_can_v0_1_vcu_info_1_current_gear_decode(unpack_base->current_gear);
        phys_struct.battery_warning = by_nav_x2_can_v0_1_vcu_info_1_battery_warning_decode(unpack_base->battery_warning);
        phys_struct.current_spd_mode = by_nav_x2_can_v0_1_vcu_info_1_current_spd_mode_decode(unpack_base->current_spd_mode);
		
		
        
        phys_struct.timestamp_s = timestamp_s;
        phys_struct.timestamp_ns = timestamp_ns;
        phys_struct.crc8 = CRC;


        break;
    }

    case BY_NAV_X2_CAN_V0_1_VCU_INFO_2_FRAME_ID:
    {
        // unpack
        by_nav_x2_can_v0_1_vcu_info_2_t *unpack_base = new by_nav_x2_can_v0_1_vcu_info_2_t();
        by_nav_x2_can_v0_1_vcu_info_2_unpack(unpack_base, data, 8);

        // decode
        physical_vcu_info_2_t& phys_struct = Can::Messages::get_instance()->get_all_messages().VCU_Info_2_Signals;

		phys_struct.soc1 = by_nav_x2_can_v0_1_vcu_info_2_soc1_decode(unpack_base->soc1);
        phys_struct.soc2 = by_nav_x2_can_v0_1_vcu_info_2_soc2_decode(unpack_base->soc2);
        phys_struct.collision_status = by_nav_x2_can_v0_1_vcu_info_2_collision_status_decode(unpack_base->collision_status);
        phys_struct.motor_direction = by_nav_x2_can_v0_1_vcu_info_2_motor_direction_decode(unpack_base->motor_direction);		
        
        phys_struct.timestamp_s = timestamp_s;
        phys_struct.timestamp_ns = timestamp_ns;
        phys_struct.crc8 = CRC;


        break;
    }
    
    default:

        break;
    }
}
